//+------------------------------------------------------------------+
//|                                         exp v5.mq5 |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"

//---       
#define __LAST_ERR_CHART_WRONG_ID_void__  ChartGetInteger(chart_id,CHART_MODE);if(GetLastError()==ERR_CHART_WRONG_ID){ResetLastError();return;}ResetLastError();
#define __LAST_ERR_CHART_WRONG_ID__  ChartGetInteger(chart_id,CHART_MODE);if(GetLastError()==ERR_CHART_WRONG_ID){ResetLastError();return(0);}ResetLastError();
#define __LAST_ERR_CHART_WRONG_ID(chart_id)  ChartGetInteger(chart_id,CHART_MODE);if(GetLastError()==ERR_CHART_WRONG_ID){ResetLastError();continue;}ResetLastError();
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
input string report="";                     //  html-  
input string Symbols="";                    //   
input bool   end_delet_charts=true;         //     
input datetime beg_time=-1;                 //  
input datetime end_time=-1;                 //  
//+------------------------------------------------------------------+
input ENUM_TIMEFRAMES Period_Gen=PERIOD_M5; //  
input string fond_comment="Arial Narrow";   //    
input int    fond_size=8;                   //     
input color  ColorBuy =clrBlue;             //   
input color  ColorSell=clrRed;              //   
input int    SPEED_LIMIT=5;                 //  
input int    Size_button_prog=8;            // .   
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
//| "Include\\Player5.mqh"                                           |
//|     "Player5_1.mqh"                                              |
//|         "Parser_Tester.mqh"                                      |
//|             "Decode MarketWatch.mqh"                             |
//|             "HTML.mqh"                                           |
//|             "Table.mqh"                                          |
//|         "Balance.mqh"                                            |
//|             <Arrays\ArrayLong.mqh>                               |
//|         "Ruler.mqh"                                              |
//+------------------------------------------------------------------+ 
#include "Include\\Player5.mqh" 
//+------------------------------------------------------------------+
//|******************************************************************|
//+------------------------------------------------------------------+

string Symbol_buf[];      //    
int totals;               //   
long arrayID[];           //  ID 
CPlayer player[];         //    
string trade_symbols[];   //      
datetime Time=0;          //    
long Chart_ID;            // ID     
int nn;                   //    
int timer=60;             //  
datetime begtime_,endtime_; //     
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//         
   Chart_ID=ChartID();
   ChartSetInteger(Chart_ID,CHART_AUTOSCROLL,false);
   ChartSetInteger(Chart_ID,CHART_SHOW_ASK_LINE,false);
   ChartSetInteger(Chart_ID,CHART_SHOW_BID_LINE,false);
   ChartSetInteger(Chart_ID,CHART_SHOW_LAST_LINE,false);
   ChartSetInteger(Chart_ID,CHART_SHOW_OHLC,false);
   CChartData bases; bases.Update(ChartID());
//      
   sp.g.fond_comments=fond_comment;
   sp.g.font_sizes=fond_size;
   sp.g.colorBuy  =ColorBuy;
   sp.g.colorSell =ColorSell;
   Comment("OnInit     ");
   CParser_Tester *pars=new CParser_Tester();
   pars.ParserOnStart(report);

   if(beg_time<0)begtime_=pars.begtime; else begtime_=beg_time;
   if(end_time<0)endtime_=pars.endtime; else endtime_=end_time;
//---    1    
   datetime null_time=TimeBars(0,_Symbol,_Period);
   int beg_=Bars(_Symbol,_Period,null_time,begtime_)+1;
   int end_=Bars(_Symbol,_Period,null_time,endtime_)-3;
   begtime_=TimeBars(beg_,_Symbol,_Period);
   endtime_=TimeBars(end_,_Symbol,_Period);
   Comment("OnInit     ");
   ArrayCopy(trade_symbols,pars.trade_symbol);//      
   Balance_Process(report,pars.trade_symbol);//      
   DebugBreak();
//---    
   string temp_sym=Symbols;
   if(temp_sym!="")StringToUpper(temp_sym);
//---    
   for(int i=0;i<pars.dec.symbol_total;i++)
     {
      if(StringFind(temp_sym,pars.dec.symbol[i])!=-1)
        {
         int size=ArraySize(Symbol_buf);
         ArrayResize(Symbol_buf,size+1);
         Symbol_buf[size]=pars.dec.symbol[i];
        }
     }
   if(ArraySize(Symbol_buf)==0)//    
      ArrayCopy(Symbol_buf,trade_symbols);//    

   Time=begtime_;//    
//---
   totals=ArraySize(Symbol_buf);

   Comment("OnInit     ");
   ChartTotal(arrayID);//      
   for(int i=0;i<totals;i++)
     {
      ChartOpen(Symbol_buf[i],bases.period); //  
      Sleep(100);
     }
   CurrentChart(arrayID);//     

//---   
   totals=ArraySize(arrayID);
   ArrayResize(player,totals);
   ArrayResize(table,totals);

   Comment("OnInit     ");
   for(int i=0;i<totals;i++)
     {
      Comment("OnInit      "+ChartSymbol(arrayID[i]));
      //---     
      pars.HistoryDrawOnProcess(GetPointer(table[i]),arrayID[i]);
      //---   
      player[i].Create(GetPointer(table[i]),
                       arrayID[i],
                       GetPointer(bases),
                       begtime_,
                       endtime_,
                       Period_Gen,
                       SPEED_LIMIT,
                       end_delet_charts,
                       Size_button_prog
                       );
     }     
   delete pars;//     CParser_Tester
   
//---
   nn=totals-1;
   player[nn].sb.state=true;//          
   player[nn].Update();
   Comment("  ,    .");
//---  

   EventSetTimer(timer);
   OnTimer();
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   EventKillTimer();
   string name_file;
   int total=ArraySize(trade_symbols);
   if(end_delet_charts)//     
     {//   
      for(int i=0;i<total;i++)
        {
         name_file=report+" "+trade_symbols[i]+".csv";
         FileDelete(name_file);
        }
      name_file=report+" "+"All balance "+".csv";
      FileDelete(name_file);
     }
//   
   for(int i=0;i<total;i++)
     {
      name_file=trade_symbols[i]+" sym.dat";
      FileDelete(name_file);
     }
   name_file="All sym.dat";
   FileDelete(name_file);
   Comment("");
   ObjectsDeleteAll(Chart_ID,0);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   uint sleep=20;//  
   uint start=GetTickCount();
   while(!IsStopped() && start+timer*1000-(sleep+5)>=GetTickCount())
     {
      nn=Click(nn);                  //    
      Time=player[nn].Progress(Time);//   ,       
      CopyPlayer(nn);                //           
      Play(Time);                    //   ,  ,  
      Sleep(sleep);                  //  
     }
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
int Click(int N)
  {
   int ntemp=N;
   for(int i=0;i<totals;i++)
     {
      __LAST_ERR_CHART_WRONG_ID(player[i].chart_id)
      if(player[i].EventClick()){ntemp=i;break;}
     }
   player[ntemp].Update();
   return(ntemp);
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void CopyPlayer(int N)
  {
   for(int i=0;i<totals;i++)
     {
      __LAST_ERR_CHART_WRONG_ID(Chart_ID)
      if(i!=N)
         player[i].Copy(GetPointer(player[N]));
     }
  }
//+------------------------------------------------------------------+
//|   ,                                |
//+------------------------------------------------------------------+
void Play(datetime time)
  {
   for(int i=0;i<totals;i++)
     {
      __LAST_ERR_CHART_WRONG_ID(Chart_ID)
      player[i].Draw(time);
      player[i].Navigate(time);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void CurrentChart(long &chart_id[])
  {
   long CurrChart[],buf[];int size=0;
   ChartTotal(CurrChart);
   int total=ArraySize(CurrChart);
   int Total=ArraySize(chart_id);
   for(int i=0;i<total;i++)
     {
      bool flag=true;
      for(int j=0;j<Total;j++)
        {
         if(CurrChart[i]==chart_id[j])flag=false;
        }
      if(flag)
        {
         size=ArrayResize(buf,size+1);buf[size-1]=CurrChart[i];
        }
     }
   ArrayCopy(chart_id,buf);
   return;
  }
//+------------------------------------------------------------------+
//|  ID                                          |
//+------------------------------------------------------------------+
void ChartTotal(long &ChartId[])
  {
   int size=0;//  
//---    
   long currChart=-1,prevChart=ChartFirst();
   size=ArrayResize(ChartId,1);ChartId[size-1]=prevChart;

   while(!IsStopped())//   break      
     {
      currChart=ChartNext(prevChart); //      
      if(currChart<0) break;          //    
      size=ArrayResize(ChartId,size+1);ChartId[size-1]=currChart;
      prevChart=currChart;//      ChartNext()      
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
