//+------------------------------------------------------------------+
//|                                                    Player5_1.mqh |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#include "Parser_Tester.mqh"
#include "Balance.mqh"
#include "Ruler.mqh" 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountTF=8;
ENUM_TIMEFRAMES TFarray[8]=
  {
   PERIOD_M1,
//PERIOD_M2,
//PERIOD_M3,
//PERIOD_M4,
   PERIOD_M5,
//PERIOD_M6,
   PERIOD_M10,
//PERIOD_M12,
   PERIOD_M15,
//PERIOD_M20,
   PERIOD_M30,
   PERIOD_H1,
   PERIOD_H2,
//PERIOD_H3,
   PERIOD_H4
//PERIOD_H6,
//PERIOD_H8
  };
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
int MinuteTF(ENUM_TIMEFRAMES tf){return(PeriodSeconds(tf)/60);}
//+------------------------------------------------------------------+
//|      TFarray[]                             |
//+------------------------------------------------------------------+
int SerchTF(ENUM_TIMEFRAMES period)
  {
   int i;
   for(i=0;i<CountTF;i++)
      if(TFarray[i]==period)break;
   if(i==CountTF)return(i-1);
   else return(i);
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int SerchTFLess(ENUM_TIMEFRAMES period)
  {
   int i;
   if(TFarray[0]==period)return(0);
   for(i=1;i<CountTF;i++)
     {
      if(TFarray[i]==period)break;
      else
        {
         if(TFarray[i]>period && TFarray[i-1]<period)
           {
            i--;
            break;
           }
        }
     }
   if(i==CountTF)return(i-1);
   else return(i);
  }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+  
datetime TimeBars(int bar,string symbol,ENUM_TIMEFRAMES period)
  {datetime temp[];CopyTime(symbol,period,bar,1,temp);return(temp[0]);};
//+------------------------------------------------------------------+
//|  .                |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| time to X                                                        |
//+------------------------------------------------------------------+
/*int WindowGetX(long chart_id,datetime T)
  {
   datetime temp[]; int bar=(int)ChartGetInteger(chart_id,CHART_FIRST_VISIBLE_BAR);
   CopyTime(ChartSymbol(chart_id),ChartPeriod(chart_id),bar,1,temp);
   double PS=(double)PeriodSeconds(ChartPeriod(chart_id));//IsStopped(__FUNCTION__);
   if(PS==0)return(-1);
   return((int)NormalizeDouble((T-temp[0])/PS*pow(2,ChartGetInteger(chart_id,CHART_SCALE)),0));
  }*/
//+------------------------------------------------------------------+
//| price to Y                                                       |
//+------------------------------------------------------------------+
int WindowGetY(long chart_id,double P)
  {
   double MiniMax=ChartGetDouble(chart_id,CHART_PRICE_MAX)-ChartGetDouble(chart_id,CHART_PRICE_MIN);
   if(MiniMax==0)return(-1);
   return((int)((ChartGetDouble(chart_id,CHART_PRICE_MAX)-P)*
          (ChartGetInteger(chart_id,CHART_HEIGHT_IN_PIXELS)/(MiniMax))));
  }
//+------------------------------------------------------------------+
//| X to time                                                        |
//+------------------------------------------------------------------+
/*datetime WindowGetTime(long chart_id,int X)
  {
   datetime temp[]; int bar=(int)ChartGetInteger(chart_id,CHART_FIRST_VISIBLE_BAR);
   CopyTime(ChartSymbol(chart_id),ChartPeriod(chart_id),bar,1,temp);
   double PP=(double)pow(2,ChartGetInteger(chart_id,CHART_SCALE));
   if(PP)return(-1);
   return((datetime)((temp[0]+X/PP)*PeriodSeconds(ChartPeriod(chart_id))));
  }
//+------------------------------------------------------------------+
//| Y to price                                                       |
//+------------------------------------------------------------------+
double WindowGetPrice(long chart_id,int Y)
  {
   double MiniMax=ChartGetDouble(chart_id,CHART_PRICE_MAX)-ChartGetDouble(chart_id,CHART_PRICE_MIN);
   if(MiniMax==0)return(-1);
   long HP=ChartGetInteger(chart_id,CHART_HEIGHT_IN_PIXELS);
   if(HP==0)return(-1);
   return(ChartGetDouble(chart_id,CHART_PRICE_MAX)-Y/(HP/MiniMax));
  }*/
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
class SBase
  {
public:
   bool              play;     //  
   int               progress; // 
   int               speed;    // 
   bool              speed_var;//    [/]
   datetime          time;     //  1
   datetime          time_bar; //   
   bool              state;    //   ( )
   bool              new_bar;  //   
   int               progress_count;//     
   int               YDISTANCE;     // Y   
   long              tackt;         //  
   int               per_size;      //     
   ENUM_TIMEFRAMES   period_gen;    //   
   bool              on_balance;    //    on/off
   bool              all_balance;   //    all/sym
   bool              flag_data;     //   
   int               win_ind;       //   

                     SBase()
     {
      play=0;progress=0;speed=1;time=0;time_bar=0;state=0;speed_var=0;new_bar=1;
      period_gen=1;progress_count=100;progress=0;tackt=0;per_size=0;
      on_balance=0;all_balance=0;YDISTANCE=17;flag_data=0;win_ind=-1;
     };
                    ~SBase(){};
   void              Copy(SBase *sor);
  };
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void SBase::Copy(SBase *sor)
  {
   play=sor.play;         //  
   progress=sor.progress; // 
   speed=sor.speed;       // 
   time=sor.time;         //  1
   time_bar=sor.time_bar; //   
   state=!sor.state;      //   ( )
   new_bar=sor.new_bar;   //       
   tackt=sor.tackt;       // 
   period_gen=sor.period_gen; //   
   speed_var=sor.speed_var;   //    [/]
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
class CChartData
  {
public:
   long              width_in_bars;      //     
   long              width_in_pixels;    //     
   long              height_in_pixels;   //    
   long              first_visible_bar;  //       
   double            pointer_per_bar;    //         

   color             bgcolor;         //   
   color             fgcolor;         //  ,    OHLC
   color             bidcolor;        //   Bid-
   color             upcolor;         //   ,      
   color             downcolor;       //   ,      
   color             bearcolor;       //    
   color             bullcolor;       //    
   color             linecolor;       //       ""
   int               mode;            //   (,   )
   int               scale;           // ,  0  5
   bool              show_per_step;   //      
   bool              show_grid;       //    
   bool              chart_schift;    //       
   double            schift_size;     //         % ( 10  50 )   
   ENUM_TIMEFRAMES   period;          // 

                     CChartData()// 
     {
      width_in_bars=0;      //     
      width_in_pixels=0;    //     
      height_in_pixels=0;   //    
      first_visible_bar=0;  //       
      pointer_per_bar=0;    //         

      bgcolor=0;         //   
      fgcolor=0;         //  ,    OHLC
      bidcolor=0;        //   Bid-
      upcolor=0;         //   ,      
      downcolor=0;       //   ,      
      bearcolor=0;       //    
      bullcolor=0;       //    
      linecolor=0;       //       ""
      mode=0;            //   (,   )
      scale=0;           // ,  0  5
      show_per_step=0;   //      
      show_grid=0;       //    
      chart_schift=0;    //       
      schift_size=0;     //         % ( 10  50 )   
      period=0;          // 

     };
                    ~CChartData(){};// 
   //---   
   void              Update(long chart_id);
   //---     
   void              ApplyTemplate(long chart_id,CChartData *b);
  };
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
void  CChartData::Update(long chart_id)
  {
   while(!IsStopped())
     {
      width_in_bars=ChartGetInteger(chart_id,CHART_WIDTH_IN_BARS);
      if(width_in_bars!=0)break;
      Sleep(10);
     }

   width_in_pixels=ChartGetInteger(chart_id,CHART_WIDTH_IN_PIXELS);
   height_in_pixels=ChartGetInteger(chart_id,CHART_HEIGHT_IN_PIXELS);
   first_visible_bar=ChartGetInteger(chart_id,CHART_FIRST_VISIBLE_BAR);

   bgcolor  =(color)ChartGetInteger(chart_id,CHART_COLOR_BACKGROUND);
   fgcolor  =(color)ChartGetInteger(chart_id,CHART_COLOR_FOREGROUND);
   bidcolor =(color)ChartGetInteger(chart_id,CHART_COLOR_BID);
   upcolor  =(color)ChartGetInteger(chart_id,CHART_COLOR_CHART_UP);
   downcolor=(color)ChartGetInteger(chart_id,CHART_COLOR_CHART_DOWN);
   bullcolor=(color)ChartGetInteger(chart_id,CHART_COLOR_CANDLE_BULL);
   bearcolor=(color)ChartGetInteger(chart_id,CHART_COLOR_CANDLE_BEAR);
   linecolor=(color)ChartGetInteger(chart_id,CHART_COLOR_CHART_LINE);

   mode     =(int)ChartGetInteger(chart_id,CHART_MODE);
   scale    =(int)ChartGetInteger(chart_id,CHART_SCALE);
   pointer_per_bar=pow(2,scale);
   show_per_step=(bool)ChartGetInteger(chart_id,CHART_SHOW_PERIOD_SEP);
   show_grid    =(bool)ChartGetInteger(chart_id,CHART_SHOW_GRID);
   chart_schift =(bool)ChartGetInteger(chart_id,CHART_SHIFT);
   schift_size  =ChartGetDouble(chart_id,CHART_SHIFT_SIZE);

   period=ChartPeriod(chart_id);
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void CChartData::ApplyTemplate(long chart_id,CChartData *b)
  {
   Update(chart_id);
   while(!IsStopped())
     {
      width_in_bars=ChartGetInteger(chart_id,CHART_WIDTH_IN_BARS);
      if(width_in_bars!=0)break;
      Sleep(10);
     }
   if(bgcolor!=b.bgcolor){ChartSetInteger(chart_id,CHART_COLOR_BACKGROUND,b.bgcolor);}
   if(fgcolor!=b.fgcolor){ChartSetInteger(chart_id,CHART_COLOR_FOREGROUND,b.fgcolor);}
   if(bidcolor!=b.bidcolor){ChartSetInteger(chart_id,CHART_COLOR_BID,b.bidcolor);}
   if(upcolor!=b.upcolor){ChartSetInteger(chart_id,CHART_COLOR_CHART_UP,b.upcolor);}
   if(downcolor!=b.downcolor){ChartSetInteger(chart_id,CHART_COLOR_CHART_DOWN,b.downcolor);}
   if(bullcolor!=b.bullcolor){ChartSetInteger(chart_id,CHART_COLOR_CANDLE_BULL,b.bullcolor);}
   if(bearcolor!=b.bearcolor){ChartSetInteger(chart_id,CHART_COLOR_CANDLE_BEAR,b.bearcolor);}
   if(linecolor!=b.linecolor){ChartSetInteger(chart_id,CHART_COLOR_CHART_LINE,b.linecolor);}
   if(mode!=b.mode){ChartSetInteger(chart_id,CHART_MODE,b.mode);}
   if(scale!=b.scale){ChartSetInteger(chart_id,CHART_SCALE,b.scale);}
   if(show_per_step!=b.show_per_step){ChartSetInteger(chart_id,CHART_SHOW_PERIOD_SEP,b.show_per_step);}
   if(show_grid!=b.show_grid){ChartSetInteger(chart_id,CHART_SHOW_GRID,b.show_grid);}
   if(chart_schift!=b.chart_schift){ChartSetInteger(chart_id,CHART_SHIFT,b.chart_schift);}

   if(chart_schift)
     {
      width_in_bars=ChartGetInteger(chart_id,CHART_WIDTH_IN_BARS);
      schift_size=ChartGetDouble(chart_id,CHART_SHIFT_SIZE);
      double temp=b.width_in_bars*b.schift_size;
      if(fabs(width_in_bars*schift_size-temp)>=100.)
        {
         temp/=(double)width_in_bars;
         ChartSetDouble(chart_id,CHART_SHIFT_SIZE,temp);
        }
     }
   if(period!=b.period)
     {
      string symbol=ChartSymbol(chart_id);
      ChartSetSymbolPeriod(chart_id,symbol,b.period);
      Sleep(100);
     }
   Update(chart_id);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*///+**************************************************************+

 CArrayRuler
 CRuler;  
 CSpeed;  
 CProgress;  
 CPlay;  
 CClick;  
 CBackGround;  
 CBarDraw;  
 CHistoryDraw;
 
/*///+**************************************************************+                                                                                                                                                                                                      //#include <Arrays\ArrayLong.mqh>
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
class CArrayRuler : public CArrayLong
  {
   SBase            *s;
public:
                     CArrayRuler(){};
                    ~CArrayRuler(){ArrayFree(m_data);};
   int               Create(SBase *base,string symbol,ENUM_TIMEFRAMES period,datetime beg,datetime end);
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
int CArrayRuler::Create(SBase *base,string symbol,ENUM_TIMEFRAMES period,datetime beg,datetime end)
  {
   s=base; //     
   int count_area=Bars(symbol,period,beg,end);
//---     
   int ff=0;
   while(!IsStopped() && count_area<=0)//  
     {
      s.flag_data=0;
      count_area=Bars(symbol,period,beg,end);
      if(count_area>0)break;
      Sleep(10);
      //        
      ff++; if(ff>6000){Print("__     "+symbol);ExpertRemove(); break;}
     }
   ArrayFree(m_data); Shutdown();
   m_data_total=count_area;
   m_data_max=((m_data_total/m_step_resize)+1)*m_step_resize;
   m_sort_mode=0;
   CopyTime(symbol,period,end,count_area,m_data);
   s.flag_data=1;
   return(count_area);
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+                                                                                                                                                                                        //+******************************************************************+
class CRuler
  {
private:
   long              chart_id;
   int               count_area;
   string            name;
   SBase            *s;
   CChartData       *d;
   ENUM_TIMEFRAMES   period;
   long              PS;
   string            symbol;
   CArrayRuler      *array;
   datetime TimeBars(int bar){datetime temp[];CopyTime(symbol,period,bar,1,temp);return(temp[0]);};
public:   
   datetime          beg; //  
   datetime          end; //  
                          
                     CRuler(){array=new CArrayRuler();};
                    ~CRuler(){delete array;};
   void              Create(long Chart_id,
                            SBase *base,
                            CChartData *data,
                            datetime beg_,
                            datetime end_,
                            ENUM_TIMEFRAMES period_=PERIOD_CURRENT);
   bool              Update(ENUM_TIMEFRAMES period_);//     
   int               Schift(){return(Bars(symbol,period,beg,TimeBars(0)));};
   int               Area(){return(count_area);};
   ENUM_TIMEFRAMES   Period(){return(period);};
   int               BarsByTime(datetime time);//    
   datetime          TimeByBars(int bar);      //    
   datetime          CastToCurr(datetime time);//      
   datetime          NextTime(datetime time);//   
   datetime          PrevTime(datetime time);//   
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CRuler::Create(long Chart_id,
                    SBase *base,
                    CChartData *data,
                    datetime beg_,
                    datetime end_,
                    ENUM_TIMEFRAMES period_=PERIOD_CURRENT)
  {
   chart_id=Chart_id;
   s=base; //     
   d=data; //     
   symbol=ChartSymbol(chart_id);//  
   if(period_!=PERIOD_CURRENT)period=period_;//      0
   else period=ChartPeriod(chart_id);//    
   PS=PeriodSeconds(period);
   beg=beg_; end=end_;//      

   count_area=array.Create(GetPointer(base),symbol,period,beg,end);

  }
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
bool CRuler::Update(ENUM_TIMEFRAMES period_)
  {
   if(period!=period_)//     
     {
      //   
      Create(chart_id,GetPointer(s),GetPointer(d),beg,end,period_);
      PS=PeriodSeconds(period);
      return(true);
     }
   else return(false);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
int CRuler::BarsByTime(datetime time)
  {
   int res=0;
   if(time<=beg)return(0);
   if(time>=end)return(count_area-1);
   if((long)time!=array.At(res))res=array.SearchLessOrEqual((long)time);
   if(res==-1)res=BarsByTime(time-PS);
   return(res);
  }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
datetime CRuler::TimeByBars(int bar)
  {
   if(bar<0)return((datetime)array.At(0));
   if(bar>count_area-1)return((datetime)array.At(count_area-1));
   return((datetime)array.At(bar));
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+  
datetime CRuler::CastToCurr(datetime time)
  {
   return(TimeByBars(BarsByTime(time)));
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
datetime CRuler::NextTime(datetime time)
  {
   return(TimeByBars(BarsByTime(time)+1));
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
datetime CRuler::PrevTime(datetime time)
  {
   return(TimeByBars(BarsByTime(time)-1));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CSpeed
  {
private:
   long              chart_id;
   string            name_left;
   string            name_right;
   string            name_var;
   string            name_bg;
   int               distance;
   SBase            *s;
   CChartData       *d;
   bool              state;
   uint              pause_time;
   int               speed_limit;
public:
                     CSpeed(){state=0;distance=21;pause_time=0;};
                    ~CSpeed()
     {
      ObjectDelete(chart_id,name_left);
      ObjectDelete(chart_id,name_right);
      ObjectDelete(chart_id,name_var);
      ObjectDelete(chart_id,name_bg);
     };
   void              Create(long Chart_id,SBase *base,CChartData *data,int speed_limit_);
   void              Update();
   void              Event_left();//      
   void              Event_right();//   
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CSpeed::Create(long Chart_id,SBase *base,CChartData *data,int speed_limit_)
  {
   chart_id=Chart_id;
   speed_limit=speed_limit_;//  
   s=base; //     
   d=data; //        
   
   name_bg="  "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_bg)<0)//    
     {//---    
      string BGP="Images_Player\\BackGroundPlayer.bmp";
      if(ObjectCreate(chart_id,name_bg,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//---       
         ObjectSetInteger(chart_id,name_bg,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //---             
         ObjectSetInteger(chart_id,name_bg,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_YDISTANCE,s.YDISTANCE-3);
         //---         
         ObjectSetString(chart_id,name_bg,OBJPROP_BMPFILE,0,BGP);
        }
      else
        {//---    ,   
         Print("    "+name_bg+".   ",GetLastError());
         ResetLastError();
        }
     }
   name_right=" Speed right "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_right)<0)//    
     {//---            
      string play="Images_Player\\Speed_y.bmp";
      string pause="Images_Player\\Speed_n.bmp";
      if(ObjectCreate(chart_id,name_right,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//---       
         ObjectSetInteger(chart_id,name_right,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_right,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //---    
         ObjectSetInteger(chart_id,name_right,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_right,OBJPROP_YDISTANCE,s.YDISTANCE+1);
         //---      ""         
         ObjectSetString(chart_id,name_right,OBJPROP_BMPFILE,1,play);
         //---      ""
         ObjectSetString(chart_id,name_right,OBJPROP_BMPFILE,0,pause);
        }
      else
        {//---    ,   
         Print("    "+name_right+".   ",GetLastError());
         ResetLastError();
        }
     }
   name_left=" Speed left "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_left)<0)//    
     {//---            
      string play="Images_Player\\y_Speed.bmp";
      string pause="Images_Player\\n_Speed.bmp";
      if(ObjectCreate(chart_id,name_left,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//---       
         ObjectSetInteger(chart_id,name_left,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_left,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //---    
         ObjectSetInteger(chart_id,name_left,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_left,OBJPROP_YDISTANCE,s.YDISTANCE+1);
         //---      ""         
         ObjectSetString(chart_id,name_left,OBJPROP_BMPFILE,1,play);
         //---      ""
         ObjectSetString(chart_id,name_left,OBJPROP_BMPFILE,0,pause);
        }
      else
        {//---    ,   
         Print("    "+name_left+".   ",GetLastError());
         ResetLastError();
        }
     }

   name_var="  "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_var)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_var,OBJ_BUTTON,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_var,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_var,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_var,OBJPROP_STATE,false);
         //---       
         ObjectSetInteger(chart_id,name_var,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chart_id,name_var,OBJPROP_YDISTANCE,s.YDISTANCE+1);
         ObjectSetInteger(chart_id,name_var,OBJPROP_XSIZE,distance-2);
         ObjectSetInteger(chart_id,name_var,OBJPROP_YSIZE,s.YDISTANCE);
         ObjectSetInteger(chart_id,name_var,OBJPROP_FONTSIZE,10);
         ObjectSetString(chart_id,name_var,OBJPROP_FONT,"Arial Narrow");
         ObjectSetInteger(chart_id,name_var,OBJPROP_COLOR,Black);
         ObjectSetInteger(chart_id,name_var,OBJPROP_BGCOLOR,(long)C'208,211,219');
        }
      else
        {//---    ,   
         Print("    "+name_var+".   ",GetLastError());
         ResetLastError();
        }
     }
   Update();
  };
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void CSpeed::Update()
  {
   Event_right(); Event_left();//   

   if(s.speed<1)s.speed=1;
   if(s.speed>=speed_limit)s.speed=speed_limit-1;//    speed
   string Text;
   if(ObjectGetInteger(chart_id,name_var,OBJPROP_STATE))
     {
      Text=EnumToString(s.period_gen);
      StringReplace(Text,"PERIOD_","");
      ObjectSetInteger(chart_id,name_var,OBJPROP_FONTSIZE,7);
     }
   else
     {
      Text=s.speed<10?" "+(string)s.speed:(string)s.speed;
      ObjectSetInteger(chart_id,name_var,OBJPROP_FONTSIZE,10);
     }
   ObjectSetString(chart_id,name_var,OBJPROP_TEXT,Text);
//---  ( )  

   long temp=d.width_in_pixels/2-33;//    X  

   ObjectSetInteger(chart_id,name_bg,OBJPROP_XDISTANCE,temp+42-1000);
   ObjectSetInteger(chart_id,name_right,OBJPROP_XDISTANCE,temp-distance*1);
   ObjectSetInteger(chart_id,name_var,OBJPROP_XDISTANCE,temp-distance*2);
   ObjectSetInteger(chart_id,name_left,OBJPROP_XDISTANCE,temp-distance*3);

   if(s.state)//   
     {
      ObjectSetInteger(chart_id,name_bg,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_right,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_var,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_left,OBJPROP_BACK,0);
      s.speed_var=ObjectGetInteger(chart_id,name_var,OBJPROP_STATE);
     }
   else //     
     {
      ObjectSetInteger(chart_id,name_bg,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_right,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_var,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_left,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_var,OBJPROP_STATE,s.speed_var);
     }
  };
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void CSpeed::Event_left()
  {
//---                
   if((bool)ObjectGetInteger(chart_id,name_left,OBJPROP_STATE))
     {
      if(!state)//    
        {
         state=true; pause_time=GetTickCount();
         //---     
         if(ObjectGetInteger(chart_id,name_var,OBJPROP_STATE))
           {
            int temp=SerchTF(s.period_gen); //     
            if(temp>0)s.period_gen=TFarray[temp-1];
           }
         else s.speed--;// ,   1
        }
      else
        {//      
         if(GetTickCount()-pause_time>40)
           {
            state=false; pause_time=0;
            ObjectSetInteger(chart_id,name_left,OBJPROP_STATE,false);
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void CSpeed::Event_right()
  {
//---       
   if((bool)ObjectGetInteger(chart_id,name_right,OBJPROP_STATE))
     {
      if(!state)//    
        {
         state=true; pause_time=GetTickCount();
         //---     
         if(ObjectGetInteger(chart_id,name_var,OBJPROP_STATE))
           {
            int temp=SerchTF(s.period_gen); //     
            if(temp<CountTF-1)
              {
               if(MinuteTF(TFarray[temp+1])<=MinuteTF(d.period)/2)s.period_gen=TFarray[temp+1];
              }
           }
         else s.speed++;// ,   1
        }
      else
        {//      
         if(GetTickCount()-pause_time>40)
           {
            state=false; pause_time=0;
            ObjectSetInteger(chart_id,name_right,OBJPROP_STATE,false);
           }
        }
     }
  }
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
class CProgress
  {
private:
   long              chart_id;
   string            name[];
   SBase            *s;
   CChartData       *d;
   void              CreateButton(int n,int size_button);
   int               Trigger();
public:
   bool              state[];
                     CProgress(){};
                    ~CProgress()
     {
      for(int i=0;i<s.progress_count;i++)
         ObjectDelete(chart_id,name[i]);
     };
   void              Create(long Chart_id,SBase *base,CChartData *data,int size_button_);
   void              Update();
   void              SetState(int i)
     {
      int j=i; if(j<0)j=0; if(j>=s.progress_count)j=s.progress_count-1;
      ObjectSetInteger(chart_id,name[j],OBJPROP_STATE,true);Trigger();
     };
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CProgress::Create(long Chart_id,SBase *base,CChartData *data,int size_button_)
  {
   chart_id=Chart_id;
   s=base; //     
   d=data; //     
   ArrayResize(name,(int)s.progress_count);
   ArrayResize(state,(int)s.progress_count);
   ArrayInitialize(state,false);
   for(int i=0;i<s.progress_count;i++)
      CreateButton(i,size_button_);
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void CProgress::CreateButton(int i,int size_button)
  {
   int Psize_button=size_button/2;
   name[i]=" "+(i<10?" "+(string)i:(string)i)+" "+ChartSymbol(chart_id);

   if(ObjectFind(chart_id,name[i])<0)//    
     {//---            
      if(ObjectCreate(chart_id,name[i],OBJ_BUTTON,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name[i],OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name[i],OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name[i],OBJPROP_STATE,false);
         //---       
         ObjectSetInteger(chart_id,name[i],OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //---    
         double k=(d.width_in_pixels/2-26.)/s.progress_count;
         ObjectSetInteger(chart_id,name[i],OBJPROP_XDISTANCE,(int)(i*k));
         ObjectSetInteger(chart_id,name[i],OBJPROP_XSIZE,12);
         ObjectSetInteger(chart_id,name[i],OBJPROP_YSIZE,size_button);
         ObjectSetInteger(chart_id,name[i],OBJPROP_BGCOLOR,Silver);

         if(i%2==0)
            ObjectSetInteger(chart_id,name[i],OBJPROP_YDISTANCE,s.YDISTANCE+22);
         else
            ObjectSetInteger(chart_id,name[i],OBJPROP_YDISTANCE,s.YDISTANCE+22+Psize_button);
        }
      else
        {//---    ,   
         Print("    "+name[i]+".   ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void CProgress::Update()
  {
   double k=(d.width_in_pixels/2-26.)/s.progress_count;
   for(int i=0;i<s.progress_count;i++)
     {
      int temp=(int)(i*k);
      ObjectSetInteger(chart_id,name[i],OBJPROP_XDISTANCE,temp);
     }
   if(s.state)//   
     {
      for(int i=0;i<s.progress_count;i++)
         ObjectSetInteger(chart_id,name[i],OBJPROP_BACK,0);
      s.progress=Trigger();
     }
   else //     
     {
      for(int i=0;i<s.progress_count;i++)
         ObjectSetInteger(chart_id,name[i],OBJPROP_BACK,1);
      SetState(s.progress);
     }
  };
//+------------------------------------------------------------------+
//|                                                            |
//+------------------------------------------------------------------+
int CProgress::Trigger()
  {
   int t=0,k=-1,pgc=s.progress_count;
   for(int i=0;i<pgc;i++)//   
     {
      if(IsStopped())break;
      if(ObjectGetInteger(chart_id,name[i],OBJPROP_STATE)==true)
        {
         if(state[i]==true)t=i;
         else {k=i;break;}
        }
     }
   if(k!=-1)//   
     {
      ObjectSetInteger(chart_id,name[k],OBJPROP_STATE,true); state[k]=true;
      ObjectSetInteger(chart_id,name[k],OBJPROP_BGCOLOR,Red);
      
      for(int i=0;i<s.progress_count;i++)
        {
         if(IsStopped())break;
         if(i<k)
           {
            ObjectSetInteger(chart_id,name[i],OBJPROP_STATE,false);
            state[i]=false;
            ObjectSetInteger(chart_id,name[i],OBJPROP_BGCOLOR,Tan);
           }
         if(i>k)
           {
            ObjectSetInteger(chart_id,name[i],OBJPROP_STATE,false);
            state[i]=false;
            ObjectSetInteger(chart_id,name[i],OBJPROP_BGCOLOR,Silver);
           }
        }
      return(k);
     }
   else return(t);// 
  };
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//|  /                                                 |
//+------------------------------------------------------------------+
class CPlay
  {
private:
   long              chart_id;
   string            name_control;
   string            name_on_balance;
   string            name_all_balance;
   string            name_ind;
   int               handle;
   ushort            custom_event_id_All;   //      All
   ushort            custom_event_id_Sym;   //      Sym
   long              lparam;                //   long
   double            dparam;                //   double
   string            sparam;                //   
   bool              state1;                // ---
   bool              state2;                //   
   bool              prev_state;            // ---
   bool              ind_state;             // ---
   ENUM_TIMEFRAMES   prev_period;
   int               ind_total;

   SBase            *s;
   CChartData       *d;
   void              IndicatorDelete(int ind_total);
   void              EventIndicators(bool &prev_state);
   void              StateIndicators();
   void              Ind_Balance_Create();
public:
   bool              state;
                     CPlay()
     {
      state=0;
      name_ind="Ind Balance";
      custom_event_id_All=10203;   //      All
      custom_event_id_Sym=10204;   //      Sym
      lparam=0;                    //   long
      dparam=0.;                   //   double
      sparam="";                   //   
      state1=0;
      state2=0;
      prev_state=1;
      ind_state=0;
     };
                    ~CPlay()
     {
      ObjectDelete(chart_id,name_control);
      ObjectDelete(chart_id,name_on_balance);
      ObjectDelete(chart_id,name_all_balance);
      //   
      state1=true;
      ind_total=ChartIndicatorsTotal(chart_id,s.win_ind);
      IndicatorDelete(ind_total);
     };
   void              Create(long Chart_id,SBase *base,CChartData *data);
   void              Update();
   void              Set_Play(bool play){ObjectSetInteger(chart_id,name_control,OBJPROP_STATE,play);}
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CPlay::Create(long Chart_id,SBase *base,CChartData *data)
  {
   chart_id=Chart_id;
   lparam=chart_id; //  id     
   s=base; //     
   d=data; //     
   prev_period=d.period;
   string play,pause;
   name_control="  "+ChartSymbol(chart_id);

   if(ObjectFind(chart_id,name_control)<0)//    
     {//---    
      play="Images_Player\\Button_Play.bmp";
      pause="Images_Player\\Button_Pause.bmp";
      if(ObjectCreate(chart_id,name_control,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//---       
         ObjectSetInteger(chart_id,name_control,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_control,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //---    
         ObjectSetInteger(chart_id,name_control,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_control,OBJPROP_YDISTANCE,s.YDISTANCE);
         //---      ""         
         ObjectSetString(chart_id,name_control,OBJPROP_BMPFILE,1,play);
         //---      ""
         ObjectSetString(chart_id,name_control,OBJPROP_BMPFILE,0,pause);
         Update();
        }
      else
        {//---    ,   
         Print("    "+name_control+".   ",GetLastError());
         ResetLastError();
        }
     }

   name_all_balance=" all_balance "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_all_balance)<0)//    
     {
      play="Images_Player\\buttton_balance_all.bmp";
      pause="Images_Player\\buttton_balance_sym.bmp";
      //---            
      if(ObjectCreate(chart_id,name_all_balance,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_STATE,false);
         //---       
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_YDISTANCE,s.YDISTANCE-1);
         //---      ""         
         ObjectSetString(chart_id,name_all_balance,OBJPROP_BMPFILE,1,play);
         //---      ""
         ObjectSetString(chart_id,name_all_balance,OBJPROP_BMPFILE,0,pause);

        }
      else
        {//---    ,   
         Print("    "+name_all_balance+".   ",GetLastError());
         ResetLastError();
        }
     }
   name_on_balance=" on_balance "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_on_balance)<0)//    
     {
      play="Images_Player\\buttton_balance_off.bmp";
      pause="Images_Player\\buttton_balance_on.bmp";
      //---            
      if(ObjectCreate(chart_id,name_on_balance,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_STATE,false);

         //---       
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_YDISTANCE,s.YDISTANCE-1);

         //---      ""         
         ObjectSetString(chart_id,name_on_balance,OBJPROP_BMPFILE,1,play);
         //---      ""
         ObjectSetString(chart_id,name_on_balance,OBJPROP_BMPFILE,0,pause);
        }
      else
        {//---    ,   
         Print("    "+name_on_balance+".   ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void CPlay::Update()
  {
   long temp=d.width_in_pixels/2;//    X  
   ObjectSetInteger(chart_id,name_control,OBJPROP_XDISTANCE,temp-26);
   ObjectSetInteger(chart_id,name_all_balance,OBJPROP_XDISTANCE,temp-161);
   ObjectSetInteger(chart_id,name_on_balance,OBJPROP_XDISTANCE,temp-199);
   dparam=(double)s.win_ind;
   if(s.state)//   
     {
      s.play=(bool)ObjectGetInteger(chart_id,name_control,OBJPROP_STATE);
      ObjectSetInteger(chart_id,name_control,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_all_balance,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_on_balance,OBJPROP_BACK,0);
     }
   else //     
     {
      ObjectSetInteger(chart_id,name_control,OBJPROP_STATE,s.play);
      ObjectSetInteger(chart_id,name_control,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_all_balance,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_on_balance,OBJPROP_BACK,1);
     }
   if(s.flag_data)
     {
      //---   
      state2=(bool)ObjectGetInteger(chart_id,name_all_balance,OBJPROP_STATE);
      state1=(bool)ObjectGetInteger(chart_id,name_on_balance,OBJPROP_STATE);
      if(prev_period!=d.period)
        {
         //   
         ind_state=false;
         //  
         ind_total=ChartIndicatorsTotal(chart_id,s.win_ind);
         IndicatorDelete(ind_total);

         prev_period=d.period;
        }
      StateIndicators();// / 
      //---
      EventIndicators(prev_state);//  

      ind_total=ChartIndicatorsTotal(chart_id,s.win_ind);
      if((ind_total>1 && state1) || (ind_total>0 && !state1))
        {
         //  
         IndicatorDelete(ind_total);
        }
     }
//--- 
  };
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void CPlay::StateIndicators()
  {
   if(state1 && !ind_state)
     {
      //  
      Ind_Balance_Create();//   
      ind_state=true;
      //--- 
      double temp_arr[];
      int copy_size=CopyBuffer(handle,0,0,10,temp_arr);
      if(copy_size==10)//        
        {
         ushort custom_event=10205; sparam="10205";
         EventChartCustom(chart_id,custom_event,lparam,dparam,sparam);
         //Print("custom_event >>");
         prev_state=!prev_state;
         EventIndicators(prev_state);//   
        }
     }
   if(!state1 && ind_state)
     {
      //        
      ind_total=ChartIndicatorsTotal(chart_id,s.win_ind);
      IndicatorDelete(ind_total);
      ind_state=false;
     }
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
void CPlay::EventIndicators(bool &prev_state)
  {
   if(!state2 && prev_state)
     {
      //  All
      sparam="10203 All";
      EventChartCustom(chart_id,custom_event_id_All,lparam,dparam,sparam);
      prev_state=false;
     }
   if(state2 && !prev_state)
     {
      //  Sym
      sparam="10204 Sym";
      EventChartCustom(chart_id,custom_event_id_Sym,lparam,dparam,sparam);
      prev_state=true;
     }
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void CPlay::IndicatorDelete(int ind_total)
  {
//  
   int total_wind=(int)ChartGetInteger(chart_id,CHART_WINDOWS_TOTAL);
   for(int j=0;j<total_wind;j++)
     {
      int beg_ind=0;
      if(ind_total>1 && state1)beg_ind=1;
      if(ind_total>0 && !state1)beg_ind=0;

      for(int i=beg_ind;i<ind_total;i++)
        {
         string short_name=ChartIndicatorName(chart_id,j,i);
         if(StringFind(short_name,name_ind,0)!=-1)
           {
            ChartIndicatorDelete(chart_id,j,short_name);
            s.win_ind=-1;
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void CPlay::Ind_Balance_Create()
  {
   int total_wind=(int)ChartGetInteger(chart_id,CHART_WINDOWS_TOTAL)-1;
   MqlParam params[]; int count_params=ArrayResize(params,1);
   params[0].type          =TYPE_STRING;
   params[0].string_value  ="Player History Trades\\"+name_ind;

   handle=IndicatorCreate(ChartSymbol(chart_id),ChartPeriod(chart_id),IND_CUSTOM,count_params,params);

   if(ChartIndicatorAdd(chart_id,s.win_ind,handle))
     { s.win_ind=total_wind+1;}
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
class CClick
  {
private:
   long              chart_id;
   string            name;
   SBase            *s;
   CChartData       *d;
public:
   bool              state;
                     CClick(){state=0;};
                    ~CClick(){ObjectDelete(chart_id,name);};
   void              Create(long Chart_id,SBase *base,CChartData *data);
   bool              Update();
   bool              Event()
     {
      bool res=(bool)ObjectGetInteger(chart_id,name,OBJPROP_STATE);
      if(res){ObjectSetInteger(chart_id,name,OBJPROP_STATE,false); s.state=true; return(true);}
      else {return(false);}
     };
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CClick::Create(long Chart_id,SBase *base,CChartData *data)
  {
   chart_id=Chart_id;
   s=base; //     
   d=data; //     
   name="  "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name,OBJ_BUTTON,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name,OBJPROP_STATE,false);
         //---       
         ObjectSetInteger(chart_id,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //---    
         Update();
        }
      else
        {//---    ,   
         Print("    "+name+".   ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
bool CClick::Update()
  {
   ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,d.bgcolor);
//---       ( )
   bool res=Event();
   if(s.state)
     {
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,d.width_in_pixels*2);
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,d.height_in_pixels*2);
     }
   else
     {
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,-10);
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,-10);
     }
//---     
   ObjectSetInteger(chart_id,name,OBJPROP_XSIZE,d.width_in_pixels*2);
   ObjectSetInteger(chart_id,name,OBJPROP_YSIZE,d.height_in_pixels*2);

   return(res);
  };
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//|                    |
//+------------------------------------------------------------------+
class CBackGround
  {
private:
   long              chart_id;
   string            name;
   SBase            *s;
   CChartData       *d;
   color             Color;
public:
   bool              state;
                     CBackGround(){state=0;};
                    ~CBackGround(){ObjectDelete(chart_id,name);};
   void              Create(long Chart_id,SBase *base,CChartData *data);
   void              Update(int bar_navigate);
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CBackGround::Create(long Chart_id,SBase *base,CChartData *data)
  {
   chart_id=Chart_id;
   s=base; //     
   d=data; //     
   name=" BackGround "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name,OBJ_RECTANGLE_LABEL,0,0,0,0,0))
        {//---     
         ObjectSetInteger(chart_id,name,OBJPROP_BACK,0);
         ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chart_id,name,OBJPROP_COLOR,d.bgcolor);
         ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,d.bgcolor);
         ObjectSetInteger(chart_id,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
         ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,0);
         Color=d.bgcolor;
         Update(0);
        }
      else
        {//---    ,   
         Print("    "+name+".   ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void CBackGround::Update(int bar_navigate)
  {
   int schift_size_pips;
   if(d.mode<2)schift_size_pips=(int)((d.first_visible_bar-bar_navigate+0.5)*d.pointer_per_bar)-1;
   else schift_size_pips=(int)((d.first_visible_bar-bar_navigate)*d.pointer_per_bar)-1;
   if(Color!=d.bgcolor)
     {
      Color=d.bgcolor;
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,d.bgcolor);
      ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,d.bgcolor);
     }
//---     
   ushort custom_event=10205; double dparam=(double)s.win_ind; string sparam="10205 BackGround";
   EventChartCustom(chart_id,custom_event,chart_id,dparam,sparam);

   ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,schift_size_pips);
   ObjectSetInteger(chart_id,name,OBJPROP_XSIZE,schift_size_pips*2);
   ObjectSetInteger(chart_id,name,OBJPROP_YSIZE,d.height_in_pixels);
  };
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
class CBarDraw
  {
private:
   long              chart_id;
   string            name_V;
   string            name_bid;
   string            name_bar_shadow;
   string            name_bar_candle;
   string            name_bar_candle_back;
   SBase            *s;
   CChartData       *d;
   string            symbol;
   int               digits;
   datetime          temp_m1[];
public:
   datetime          timeM1;
   double            open;
   double            high;
   double            low;
   double            close;
                     CBarDraw(){open=0;high=0;low=0;close=0;};
                    ~CBarDraw()
     {
      ObjectDelete(chart_id,name_V);
      ObjectDelete(chart_id,name_bid);
      ObjectDelete(chart_id,name_bar_shadow);
      ObjectDelete(chart_id,name_bar_candle);
     };
   void              Create(long Chart_id,SBase *base,CChartData *data);
   void              Update(int bar_navigate,
                            datetime time_bar,
                            datetime time_prev,
                            double close_prev,
                            double o,
                            double h,
                            double l,
                            double c
                            );
   void              Comments(double o,double h,double l,double c);
   void              Comments(string text=""){ChartSetString(chart_id,CHART_COMMENT,text);};
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CBarDraw::Create(long Chart_id,SBase *base,CChartData *data)
  {
   chart_id=Chart_id;
   s=base; //     
   d=data; //     
   symbol=ChartSymbol(chart_id);
   digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
   name_V="V "+symbol;
   if(ObjectFind(chart_id,name_V)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_V,OBJ_VLINE,0,0,0,0,0))
        {//---
        }
      else
        {//---    ,   
         Print("    "+name_V+".   ",GetLastError());
         ResetLastError();
        }
     }

   name_bar_candle_back="candle back "+symbol;
   if(ObjectFind(chart_id,name_bar_candle_back)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_bar_candle_back,OBJ_RECTANGLE_LABEL,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bgcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.linecolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BACK,0);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BORDER_TYPE,BORDER_FLAT);
         //---       
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //---          
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XSIZE,0);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YSIZE,0);
        }
      else
        {//---    ,   
         Print("    "+name_bar_candle_back+".   ",GetLastError());
         ResetLastError();
        }
     }
   name_bar_shadow="shadow "+symbol;
   if(ObjectFind(chart_id,name_bar_shadow)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_bar_shadow,OBJ_TREND,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_COLOR,d.linecolor);
         ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_WIDTH,1);
        }
      else
        {//---    ,   
         Print("    "+name_bar_shadow+".   ",GetLastError());
         ResetLastError();
        }
     }
   name_bar_candle="candle "+symbol;
   if(ObjectFind(chart_id,name_bar_candle)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_bar_candle,OBJ_RECTANGLE_LABEL,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bgcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.linecolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BACK,0);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BORDER_TYPE,BORDER_FLAT);
         //---       
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //---          
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XSIZE,0);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YSIZE,0);
        }
      else
        {//---    ,   
         Print("    "+name_bar_candle+".   ",GetLastError());
         ResetLastError();
        }
     }

   name_bid="bid "+symbol;
   if(ObjectFind(chart_id,name_bid)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_bid,OBJ_HLINE,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_bid,OBJPROP_COLOR,d.bidcolor);
        }
      else
        {//---    ,   
         Print("    "+name_bid+".   ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void CBarDraw::Update(int bar_navigate,
                      datetime time_bar,
                      datetime time_prev,
                      double close_prev,
                      double o,
                      double h,
                      double l,
                      double c
                      )
  {
   ObjectSetInteger(chart_id,name_V,OBJPROP_TIME,timeM1);
   ObjectSetDouble(chart_id,name_bid,OBJPROP_PRICE,c);
   ObjectSetInteger(chart_id,name_bid,OBJPROP_COLOR,d.bidcolor);

   if(d.mode==0)// 
     {
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BACK,0);
      //---  ----------------------          
      //---      
      int width_of_bar=((int)d.pointer_per_bar*3/4+1)/2;
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XSIZE,width_of_bar+1);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XSIZE,width_of_bar+1);
      int schift_size_pips=(int)((d.first_visible_bar-bar_navigate+0.625)*d.pointer_per_bar-1);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XDISTANCE,schift_size_pips);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XDISTANCE,schift_size_pips+width_of_bar);

      int O= WindowGetY(chart_id,o);
      int C= WindowGetY(chart_id,c);
      int scl=3-(d.scale/4);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YSIZE,scl);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YDISTANCE,O);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YSIZE,scl);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YDISTANCE,C);
      if(o>c)
        {
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bearcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.downcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bearcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.downcolor);
        }
      else
        {
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bullcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.upcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bullcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.upcolor);
        }

      //---  ---------------------- 
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_WIDTH,d.scale/4+1);

      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,0,time_bar);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,1,time_bar);

      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,0,h);
      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,1,l);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_COLOR,d.linecolor);
     }

   if(d.mode==1)// 
     {
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BACK,1);
      //---  ----------------------          
      //---      
      int width_of_bar=(int)d.pointer_per_bar*3/4+1;
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XSIZE,width_of_bar);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XSIZE,width_of_bar);
      int schift_size_pips=(int)((d.first_visible_bar-bar_navigate+0.625)*d.pointer_per_bar-1);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XDISTANCE,schift_size_pips);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XDISTANCE,schift_size_pips);

      int O= WindowGetY(chart_id,o);
      int C= WindowGetY(chart_id,c);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YSIZE,(int)fabs(O-C)+3);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YDISTANCE,fmin(O,C));
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YSIZE,(int)fabs(O-C)+3);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YDISTANCE,fmin(O,C));
      if(o>c)
        {
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bearcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.downcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bearcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.downcolor);
        }
      else
        {
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bullcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.upcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bullcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.upcolor);
        }

      //---  ---------------------- 
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_WIDTH,1);

      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,0,time_bar);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,1,time_bar);

      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,0,h);
      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,1,l);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_COLOR,d.linecolor);
     }

   if(d.mode==2)// 
     {
      //---   
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BACK,1);

      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YSIZE,2);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YDISTANCE,0);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YSIZE,2);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YDISTANCE,0);

      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XSIZE,2);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XSIZE,2);
      int schift_size_pips=(int)((d.first_visible_bar-bar_navigate+2)*d.pointer_per_bar-1);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XDISTANCE,schift_size_pips);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XDISTANCE,schift_size_pips);

      //--- 
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_WIDTH,d.scale/4+1);

      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,0,time_prev);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,1,time_bar);

      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,0,close_prev);
      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,1,c);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_COLOR,d.linecolor);
     }

  };
//+------------------------------------------------------------------+
//|   , ,,  ,.. |
//+------------------------------------------------------------------+
void CBarDraw::Comments(double o,double h,double l,double c)
  {
   string EnumString=EnumToString(d.period);
   StringReplace(EnumString,"PERIOD_","");
   string EnumStringGen=EnumToString(s.period_gen);
   StringReplace(EnumStringGen,"PERIOD_","");
   string _OHLC_=" "+DoubleToString(o,digits)+" "+DoubleToString(h,digits)+
                 " "+DoubleToString(l,digits)+" "+DoubleToString(c,digits)
                 +"     period generator "+EnumStringGen;
   ChartSetString(chart_id,CHART_COMMENT,symbol+","+EnumString+_OHLC_);
  };
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
class CHistoryDraw
  {
private:
   long              chart_id;
   string            name_text; //  
   string            name_V;    //  
   string            name_Tr;   //  
   string            name_out;  //  out 
   string            name0,name1,name2,name3;
   color             COLOR;
   datetime          time0,time1,end_pos_time;
   double            price0,price1;
   int               font_size_vol;
   int               font_size_out;
   SBase            *s;
   CChartData       *d;
   CTable           *table;        //   
   int               pos;
public:
   bool              state;

                     CHistoryDraw()
     {
      font_size_vol=8;
      font_size_out=10;
      state=0;pos=0;
      end_pos_time=0;
     };
                    ~CHistoryDraw()
     {//    
      if(ObjectFind(chart_id,name_text)>=0)
         ObjectDelete(chart_id,name_text);
      if(ObjectFind(chart_id,name_V)>=0)
         ObjectDelete(chart_id,name_V);
      if(ObjectFind(chart_id,name_Tr)>=0)
         ObjectDelete(chart_id,name_Tr);
      if(ObjectFind(chart_id,name_out)>=0)
         ObjectDelete(chart_id,name_out);
     };
   void              Create(CTable *table_,long Chart_id,SBase *base,CChartData *data);
   void              Update(datetime time,double level);
   void              FixingLast(int pos);//   
   void              RelevantPos(datetime time,double level,int pos);//     
   void              NameObject(int pos); //   4- 
   string            NameObjectSwitch(int index);//    
   void              DataObject(string name_color,string name_price);
   string            IndexObject(int pos);//     "[79][8]" 
                                          //[79]-  [8]-    
/*
      Parser_Tester.mqh 
   void              TextVol(long chart_id,string name,color COLOR,int font_size,string text,datetime time,double price);
   void              TrendLine(long chart_id,string name,color COLOR,datetime time0,datetime time1,double price0,double price1);
   void              TrendVLine(long chart_id,string name,color COLOR,datetime time0,double price0,double price1);
*/
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CHistoryDraw::Create(CTable *table_,long Chart_id,SBase *base,CChartData *data)
  {
// , , ., , , ., , ,    .
//   0     1      2        3      4        5         6        7           8  
   table=table_; if(table.SecondSize()>0){state=true; table.Get(0,table.SecondSize()-1,end_pos_time);}
   chart_id=Chart_id;
   s=base; //     
   d=data; //     

   name_text="HistoryDraw text_ "+ChartSymbol(chart_id); //  
   name_V="HistoryDraw V_ "+ChartSymbol(chart_id);       //  
   name_Tr  ="HistoryDraw Tr_ "+ChartSymbol(chart_id);     //  
   name_out ="HistoryDraw out_ "+ ChartSymbol(chart_id);   //  out 

   if(ObjectFind(chart_id,name_text)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_text,OBJ_TEXT,0,0,0))
        {//--- 
         ObjectSetInteger(chart_id,name_text,OBJPROP_BACK,0);
        }
      else
        {//---    ,   
         Print("    "+name_text+".   ",GetLastError());
         ResetLastError();
        }
     }
   if(ObjectFind(chart_id,name_V)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_V,OBJ_TREND,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_V,OBJPROP_BACK,0);
        }
      else
        {//---    ,   
         Print("    "+name_V+".   ",GetLastError());
         ResetLastError();
        }
     }
   if(ObjectFind(chart_id,name_Tr)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_Tr,OBJ_TREND,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_Tr,OBJPROP_BACK,0);
         ObjectSetInteger(chart_id,name_Tr,OBJPROP_COLOR,d.bgcolor);
        }
      else
        {//---    ,   
         Print("    "+name_Tr+".   ",GetLastError());
         ResetLastError();
        }
     }
   if(ObjectFind(chart_id,name_out)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_out,OBJ_TEXT,0,0,0))
        {//--- 
         ObjectSetInteger(chart_id,name_out,OBJPROP_BACK,0);
        }
      else
        {//---    ,   
         Print("    "+name_out+".   ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void CHistoryDraw::Update(datetime time,double level)
  {
   if(table.SecondSize()>0)//    
     {
      int prev_pos=pos;
      datetime time_pos=0,time_pos1=0; table.Get(0,pos,time_pos);
      if(pos<table.SecondSize()-1) {table.Get(0,pos+1,time_pos1);}
      //---
      if(pos>1)FixingLast(1);
      if(time<end_pos_time)
        {
         if(time_pos<=time && time_pos1>time)
           {//     
            RelevantPos(time,level,pos);
           }
         else
           {// 

            bool flag=false;
            for(int j=pos;j<table.SecondSize()-1;j++)
              {
               table.Get(0,j,time_pos);
               table.Get(0,j+1,time_pos1);
               if(time_pos<=time && time_pos1>time){pos=j;flag=true;break;}
              }
            //           
            if(!flag)
              {//      
               for(int j=1;j<pos;j++)
                 {
                  table.Get(0,j,time_pos);
                  table.Get(0,j+1,time_pos1);
                  if(time_pos<=time && time_pos1>time){pos=j;break;}
                 }
              }
            FixingLast(prev_pos);//     
            RelevantPos(time,level,pos);
           }
        }
      else
        {
         FixingLast(prev_pos);//   
         pos=table.SecondSize()-1;
         FixingLast(pos);//     
        }
     }
  }
//+------------------------------------------------------------------+
//|   ,          |
//+------------------------------------------------------------------+  
void CHistoryDraw::FixingLast(int prev_pos)
  {
   NameObject(prev_pos);
   DataObject(name0,name2);
//   
//---  2
   ObjectSetInteger(chart_id,name2,OBJPROP_COLOR,COLOR);
   ObjectSetInteger(chart_id,name2,OBJPROP_BACK,0);
//---  3
   if(ObjectFind(chart_id,name3)>=0)
     {
      ObjectSetInteger(chart_id,name3,OBJPROP_TIME,time1);
      ObjectSetDouble(chart_id,name3,OBJPROP_PRICE,price1);
     }
   sp.TrendLine(chart_id,name_Tr,COLOR,0,0,0,0);
   sp.TrendVLine(chart_id,name_V,COLOR,0,0,0);
   sp.TextVol(chart_id,name_text,COLOR,"0",0,0);
  }
//+------------------------------------------------------------------+
//|                              |
//+------------------------------------------------------------------+
void CHistoryDraw::RelevantPos(datetime time,double level,int pos)
  {
   NameObject(pos);
   DataObject(name0,name2);
//     
   if(ObjectFind(chart_id,name1)>=0)
     {
      //---  2
      ObjectSetInteger(chart_id,name2,OBJPROP_COLOR,d.bgcolor);
      ObjectSetInteger(chart_id,name2,OBJPROP_BACK,1);
      //---  3
      if(ObjectFind(chart_id,name3)>=0)
        {
         ObjectSetInteger(chart_id,name3,OBJPROP_TIME,0);
         ObjectSetDouble(chart_id,name3,OBJPROP_PRICE,0);
        }
      //   
      if(time>=time0)
        {
         sp.TrendLine(chart_id,name_Tr,COLOR,time0,time,price0,level);
         sp.TrendVLine(chart_id,name_V,COLOR,time0,price0,price1);
        }
      if(pos>=0)
        {
         string text=ObjectGetString(chart_id,name0,OBJPROP_TEXT);
         sp.TextVol(chart_id,name_text,COLOR,text,time0,price0);
        }
     }
   else
     {
      sp.TextVol(chart_id,name_out,COLOR,"out",time1,price1);
      if(pos>=0)
        {
         NameObject(pos-1);
         DataObject(name0,name2);
         sp.TrendLine(chart_id,name_Tr,COLOR,time0,time1,price0,price1);
        }
     }
  }
//+------------------------------------------------------------------+
//|    .                           |
//+------------------------------------------------------------------+
void CHistoryDraw::DataObject(string name_color,string name_price)
  {
   COLOR=(color)ObjectGetInteger(chart_id,name_color,OBJPROP_COLOR);
//---
   time0=(datetime)ObjectGetInteger(chart_id,name_price,OBJPROP_TIME,0);
   time1=(datetime)ObjectGetInteger(chart_id,name_price,OBJPROP_TIME,1);
//---
   price0=ObjectGetDouble(chart_id,name_price,OBJPROP_PRICE,0);
   price1=ObjectGetDouble(chart_id,name_price,OBJPROP_PRICE,1);
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
void CHistoryDraw::NameObject(int pos)
  {
   string temp=IndexObject(pos);
   name0=NameObjectSwitch(0)+temp;//    
   name1=NameObjectSwitch(1)+temp;//    
   name2=NameObjectSwitch(2)+temp;//    
   name3=NameObjectSwitch(3)+temp;//      
  }
//+------------------------------------------------------------------+
//|   .                    |
//+------------------------------------------------------------------+
string CHistoryDraw::NameObjectSwitch(int index)//    
  {
   switch(index)
     {
      case  0: return("Text ");     break;
      case  1: return("TrLineV ");  break;
      case  2: return("TrLine ");   break;
      case  3: return("Text out "); break;
      default: return("");          break;
     }
  }
//+------------------------------------------------------------------+
//|   [][]               |
//+------------------------------------------------------------------+
string CHistoryDraw::IndexObject(int pos)
  {
   long Npos,Ndeal;
   table.Get(7,pos,Npos);
   table.Get(8,pos,Ndeal);
   return("["+(string)Npos+"]["+(string)Ndeal+"]");
  }
//+******************************************************************+
